/*
 File: lr1_sp6sym.cpp
 Date and Time: Sun Sep 14 21:16:19 2014 
*/
#include "lr1_sp6.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_lr1_sp6;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Clr1_sp6_fsm::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Repi_test_:{
       Repi_test* sym;
     if(re->rule_ == 0){
       sym = new Repi_test(parser__);
       re->rule_ = sym;
     }else{
       sym = (Repi_test*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Repi_rt_bnd_tst_:{
       Repi_rt_bnd_tst* sym;
     if(re->rule_ == 0){
       sym = new Repi_rt_bnd_tst(parser__);
       re->rule_ = sym;
     }else{
       sym = (Repi_rt_bnd_tst*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Repi_:{
       Repi* sym;
     if(re->rule_ == 0){
       sym = new Repi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Repi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Repi_:{
       Repi* sym;
     if(re->rule_ == 0){
       sym = new Repi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Repi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Repi_eog_:{
       Repi_eog* sym;
     if(re->rule_ == 0){
       sym = new Repi_eog(parser__);
       re->rule_ = sym;
     }else{
       sym = (Repi_eog*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rlr1_sp5_:{
       Rlr1_sp5* sym;
     if(re->rule_ == 0){
       sym = new Rlr1_sp5(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlr1_sp5*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 4;
    

     return;}
    case rhs2_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 4;
    

     return;}
    case rhs3_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs4_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs5_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_RA_:{
       RA* sym;
     if(re->rule_ == 0){
       sym = new RA(parser__);
       re->rule_ = sym;
     }else{
       sym = (RA*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RB_:{
       RB* sym;
     if(re->rule_ == 0){
       sym = new RB(parser__);
       re->rule_ = sym;
     }else{
       sym = (RB*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RD_:{
       RD* sym;
     if(re->rule_ == 0){
       sym = new RD(parser__);
       re->rule_ = sym;
     }else{
       sym = (RD*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_RD_:{
       RD* sym;
     if(re->rule_ == 0){
       sym = new RD(parser__);
       re->rule_ = sym;
     }else{
       sym = (RD*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_RD_:{
       RD* sym;
     if(re->rule_ == 0){
       sym = new RD(parser__);
       re->rule_ = sym;
     }else{
       sym = (RD*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_RE_:{
       RE* sym;
     if(re->rule_ == 0){
       sym = new RE(parser__);
       re->rule_ = sym;
     }else{
       sym = (RE*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_RE_:{
       RE* sym;
     if(re->rule_ == 0){
       sym = new RE(parser__);
       re->rule_ = sym;
     }else{
       sym = (RE*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    default: return;
   }
}
